<?php

namespace STM\Match\Detail;

use STM\StmFactory;
use \Exception;

/**
 * Test class for MatchDetailValidator.
 * Generated by PHPUnit on 2012-07-10 at 11:11:59.
 * @group match_detail
 */
class MatchDetailValidatorTest extends \PHPUnit_Framework_TestCase {

    private $valid_structure;

    protected function setUp() {
        $this->valid_structure = array(
            'match' => StmFactory::find()->Match->findById (1),
            'spectators' => '200',
            'match_comment' => 'comment',
            'id_stadium' => '1'
        );
    }

    public function testCheck() {
        // argument must be array with keys 'match', 'spectators', 'match_comment', 'id_stadium'
        $this->assert_bad_arguments('checkCreate', null);
        $this->assert_bad_arguments('checkCreate', new Exception());
        // at least on optional values must be set (match is required)
        $this->assert_bad_arguments('checkCreate', array('match' => StmFactory::find()->Match->findById (1), 'spectators' => '', 'match_comment' => '', 'id_stadium' => ''));
        // match must be instanceof Match
        $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('match', null));
        // spectators must be numeric <0, 500000>
        $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('spectators', new Exception()));
        $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('spectators', -1));
        // match_comment must be string <3, 500>
        $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('match_comment', new Exception()));
        $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('match_comment', 'a'));
        // id_stadium must be id of existing stadium
        $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('id_stadium', new Exception()));
        $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('id_stadium', -1));
        // OK
        $match = StmFactory::find()->Match->findById (1);
        if ($match && StmFactory::find()->Stadium->findById(1) && !StmFactory::find()->MatchDetail->findById($match->getId())) {
            parent::assertTrue(MatchDetailValidator::checkCreate($this->valid_structure));
        }
    }

    public function testCheck_change_in_match_detail() {
        $match_detail = StmFactory::find()->MatchDetail->findById(5);
        if ($match_detail) {
            // detail must be set
            $this->assert_bad_arguments('checkChangeInMatchDetail', $this->valid_structure);
            MatchDetailValidator::setMatchDetail($match_detail);
            // at least one value must be different from current value
            $detailArray = $match_detail->toArray();
            $attributes = array(
                'match' => StmFactory::find()->Match->findById ($match_detail),
                'spectators' => $detailArray['spectators'],
                'match_comment' => $detailArray['match_comment'],
                'id_stadium' => $match_detail->getIdStadium()
            );
            $this->assert_bad_arguments('checkChangeInMatchDetail', $attributes);
            // OK
            $attributes['match_comment'] .= 'new text';
            parent::assertTrue(MatchDetailValidator::checkChangeInMatchDetail($attributes));
        }
    }

    private function get_modified_structure($key, $new_value) {
        $attributes = $this->valid_structure;
        $attributes[$key] = $new_value;
        return $attributes;
    }

    private function assert_bad_arguments($method, $data) {
        MatchDetailValidator::init();
        parent::assertFalse(MatchDetailValidator::$method($data));
        MatchDetailValidator::init();
    }

}

?>